require "defines"

local loaded

function ticker()
	if global.itemCollectors ~= nil then
		if global.ticks == 0 or global.ticks == nil then
			global.ticks = 59
			processCollectors()
		else
			global.ticks = global.ticks - 1
		end
	else
		game.on_event(defines.events.on_tick, nil)
	end
end

game.on_load(function()
	if not loaded then
		loaded = true
		
		if global.itemCollectors ~= nil then
			game.on_event(defines.events.on_tick, ticker)
		end
	end
end)

game.on_init(function()
	loaded = true
	
	if global.itemCollectors ~= nil then
		game.on_event(defines.events.on_tick, ticker)
	end
end)

function builtEntity(event)
	local newCollector
	
	if event.created_entity.name == "item-collector-area" then
		newCollector = game.surfaces["nauvis"].create_entity({name = "item-collector", position = event.created_entity.position, force = game.forces.player})
		event.created_entity.destroy()
		
		if global.itemCollectors == nil then
			global.itemCollectors = {}
			game.on_event(defines.events.on_tick, ticker)
		end
		
		table.insert(global.itemCollectors, newCollector)
	end
end

game.on_event(defines.events.on_built_entity, builtEntity)
game.on_event(defines.events.on_robot_built_entity, builtEntity)

function processCollectors()
	local items
	local inventory
	local belt
	
	for k,collector in pairs(global.itemCollectors) do
		if collector.valid then
			items = game.surfaces["nauvis"].find_entities_filtered({area = {{x = collector.position.x - 25, y = collector.position.y - 25}, {x = collector.position.x + 25, y = collector.position.y + 25}}, name = "item-on-ground"})
			
			if #items > 0 then
				inventory = collector.get_inventory(1)
				for _,item in pairs(items) do
					--if not item.isitemonbelt() then
						if item.stack.name == "small-alien-artifact" or
						item.stack.name == "alien-artifact" or
						item.stack.name == "small-corpse" or
						item.stack.name == "medium-corpse" or
						item.stack.name == "big-corpse" or
						item.stack.name == "berserk-corpse" or
						item.stack.name == "elder-corpse" or
						item.stack.name == "king-corpse" or
						item.stack.name == "queen-corpse" then
							if inventory.can_insert(item.stack) then
								inventory.insert(item.stack)
								item.destroy()
								break
							end
						end
					--end
				end
			end
		else
			table.remove(global.itemCollectors, k)
			if #global.itemCollectors == 0 then
				global.itemCollectors = nil
			end
		end
	end
end